# include <iostream>
# include "rect.h"
# include <cmath>
#include "parser.h"
#include <cstdlib>
#include <cstdio>
# include "ezwin.h"
#include "bitmap.h"
using namespace std;


/****************** global declarations *****************/
SimpleWindow w ( "graph" , 20,20);// declaring graph window
SimpleWindow input ( "input" , 10,10);// declaring input window
RectangleShape E(w, 0.0,0.0,Black ,80.0,80.0);//blacks out the unused space in window
RectangleShape D(w, 0.0,0.0,White ,40.0,40.0);// D is the background color
RectangleShape a(w, 18.5,1.5,Green ,1.0,1.0);// up key
RectangleShape b(w, 19.5,2.5,Green ,1.0,1.0);//right key
RectangleShape c(w, 18.5,3.5,Green ,1.0,1.0);//down key
RectangleShape d(w, 17.5,2.5,Green ,1.0,1.0);//left key
RectangleShape e (w,1.5,1.5,Red,1.0,1.0);//refresh button
RectangleShape f (input, 1.5,3.5, Red ,0.5,0.5);// button for derivative <initial> 
RectangleShape g (input, 1.5,3.5 ,Green ,0.5,0.5);//derivative <after pressed>
RectangleShape h (input, 1.5,4.5, Red ,0.5,0.5);// integral <before>
RectangleShape i (input, 1.5,4.5, Green ,0.5,0.5);// integral <after>
RectangleShape j (input, 5.5,8.5, Green ,1,1);// plot function for input window
RectangleShape k (input, 4,2, White  ,7,1);// display the function input by user in the window here
int toright=0, toup=0, ifDeri=0, ifInt=0, ifCritical =0, ifRoot=0;
char inputFunction[30]; char ch;
char str[255];
BitMap rightpic ( w);// pic over right key
BitMap leftpic (w);// pic over left key
BitMap uppic (w);// pic over up key
BitMap downpic (w);// pic over down key
BitMap plotpic (w);// pic over plot key
BitMap refreshpic (w);// currently not used
BitMap checked (input);//checkbox unmarked
BitMap unchecked (input);// checkbox marked
BitMap photo ( input);// background image of input window


/***********************************INPUT FUNCTIONS***********************************/
/*************************************************************************************/



/*********************replaces x with a num value (parser)**********************/
void convert(char *str,char *rep,char *newstr)
   	{
  	char ch;
  	ch='x';
 	 int i,j,k;
  		i=k=0;
  	 while (str[i] !='\0')
	  {
   		 if(str[i]==ch)
			for(j=0;j<strlen(rep);j++)
				newstr[k++]=rep[j];
   	 else newstr[k++]=str[i];
   	 i++;
    
 	 }
	newstr[k]='\0';
 	 
	}
	
/************************* parser function ********************************/	
float gh(float x)
{
    char arbid[56];
    char err[255],newstr[200];
    char rep[25];
    double res = 0;
    float y;
    // create a parser object
    Parser prs;
    sprintf(rep,"%f",x);
    convert(str,rep,newstr);
       
        if (strcmp(str, "") != 0)
        {
            try
            {
                // evaluate the expression
                char* result;
                result = prs.parse(newstr);
                
                
            // error dispaly if a wrong input is added
            
           if ( *result == 'E') {puts (result); exit (0);}
                sscanf(result,"%s%s%f", arbid,arbid,&y);

            }
            catch (...)
            {
                printf("\tError: Unknown error occured in parser\n");// when all is hopeless
            }
        }
    return y;
}

/************************************************OUTPUT FUNCTIONS********************************/
/************************************************************************************************/



/************** mouse click function controls the functioning of all the keys IN W window*****************/
int wMouseClick (const Position &p)
{
void plot (int,int);
float m , n;
int right =toright ,up = toup;
m=p.GetXDistance ();
n = p.GetYDistance ();
if (m>1.0 && m<3.5 && n>1.0 &&n<2.0 ) {right =0;up = 0;toright=0;toup=0; plot (right,up);}// refresh button calling
if ( m>19.0 && m < 20.0 && n > 2.0  && n < 3.0) {right++;toright++;plot(right,up);}// sil\milarly other button calling
if ( m>17.0 && m < 18.0 && n > 2.0  && n < 3.0) {right--;toright--; plot (right,up); }
if ( m>18.0 && m < 19.0 && n > 1.0  && n < 2.0) { up++;toup++;plot (right,up); }
if ( m>18.0 && m < 19.0 && n > 3.0  && n < 4.0) { up--;toup--;plot(right,up); }
}

/******************* mouse functions of input window *****************************/

int inputMouseClick ( const Position &q)
{
float m,n;
m=q.GetXDistance (); 
n = q.GetYDistance ();
if ( m >0.5 && m< 7.5 && n>0.5 && n < 1.5)
{	
}

	
if ( m>1&& m<2&& n>3&& n<4)
 { 
  if ( ifDeri==0){g.Draw();checked.SetPosition (Position (1,3));
         checked.Draw(); ifDeri =1;}
  else {f.Draw();unchecked.SetPosition (Position (1,3));
unchecked.Draw();
  	
          ifDeri =0;}
 }
 
 
if ( m>1&& m<2 && n>4&& n<5) 
{
 if ( ifInt ==0) {i.Draw();checked.SetPosition (Position (1,4));
         checked.Draw();ifInt =1; }
 else  {h.Draw();unchecked.SetPosition (Position (1,4));
unchecked.Draw();ifInt =0; }
}


if ( m>1&& m<2 && n>5&& n<6) 
{
 if ( ifCritical ==0) {checked.SetPosition (Position (1,5));
         checked.Draw();ifCritical =1; }
 else  {unchecked.SetPosition (Position (1,5));
unchecked.Draw();ifCritical =0; }
}


if ( m>1&& m<2 && n>6&& n<7) 
{
 if ( ifRoot ==0) {checked.SetPosition (Position (1,6));
         checked.Draw();ifRoot =1; }
 else  {unchecked.SetPosition (Position (1,6));
unchecked.Draw();ifRoot =0; }
}



if ( m>5&& m<6 && n>8&& n<9) {  input.Close();}
}








/************************************graph plotting functions*****************************************/


/**************************************************************************/
void graphWithCriticalpoints (  int factor,int right,int up,float acc,int iterations)
{
float ynot, k=0.0, xnot = 0.0,y,x, yderi=0,derirec;
int i;
x = right*factor - 10; float flag= 0, flagx;
ynot = y = gh(x);
yderi = 0;
for ( i=0 ; i<iterations;i++ )
{
		
	y = ynot;flagx = x;
	x += acc;
	ynot = gh(x);
      float deriRec=yderi;
      yderi=(ynot-y)/acc;
         
	if(yderi <0.1&&yderi>-0.1)
         {
          if ( flag != flagx){
          w.RenderLine (Position(xnot,10-y+factor*up),Position(xnot+acc,10-ynot+factor*up),Red,0.1);}
          flag = x;
          }
    xnot+=acc; 
}
}



/****************************************************************/
void graphWithRoots ( int factor,int right,int up,float acc,int iterations)
{
float ynot, xnot = 0.0,y,x;
int i, k=0;
x = right*factor - 10;
ynot = gh(x);  char root[10][10];
for ( i=0 ; i<iterations;i++ )
{
	
	y = ynot;
	x += acc;
	ynot = gh(x);
	if(ynot<0.01 && ynot > 0)
	{
	
	sprintf (root[k],"%.1f",x);
	 w.RenderText ( Position ( 18 ,19- k) , Position ( 20,20-k),root[k] , Black);
	k++;
	
	 }
	xnot +=acc;
}
}

/*****************************************************/
void graph ( int factor,int right,int up,float acc,int iterations)
{
float ynot, k=0.0, xnot = 0.0,y,x;
int i;
x = right*factor - 10;
ynot = gh(x);
for ( i=0 ; i<iterations;i++ )
{
	
	y = ynot;
	x += acc;
	ynot = gh(x);
	if ( y < 12+factor*up&& y> -12 +factor*up){
	w.RenderLine (Position(xnot,10-y+factor*up),Position(xnot+acc,10-ynot+factor*up),Blue,0.05);}
	xnot +=acc;
}
if ( ifCritical == 1){
graphWithCriticalpoints (  factor,right, up, acc, iterations);}
if ( ifRoot == 1) {
 graphWithRoots (  factor, right,up, acc, iterations);}
}



/******************************************************/

void graphWithDerivative (  int factor,int right,int up,float acc,int iterations)
{
float ynot, k=0.0, xnot = 0.0,y,x, yderi=0;
int i;
x = right*factor - 10;
ynot = y = gh(x);
yderi = 0;
for ( i=0 ; i<iterations;i++ )
{
		
	y = ynot;
	x += acc;
	ynot = gh(x);
	float deriRec = yderi;
	yderi = (ynot - y)/acc;
	
	if ( y < 12+factor*up&& y> -12 +factor*up){
	w.RenderLine (Position(xnot,10-y+factor*up),Position(xnot+acc,10-ynot+factor*up),Blue,0.05);}
	if ( yderi < 12+factor*up&& yderi> -12 +factor*up){
	w.RenderLine (Position(xnot,10-deriRec+factor*up),Position(xnot+acc,10-yderi+factor*up),Cyan,0.05);}
	xnot +=acc;
	
}

if ( ifCritical == 1){
graphWithCriticalpoints (  factor,right, up, acc, iterations);}
if ( ifRoot == 1) {
 graphWithRoots (  factor, right,up, acc, iterations);}
}


/************************************************************/

void graphWithIntegral (  int factor,int right,int up,float acc,int iterations)
{

float ynot,xnot=0,y,x;float yval;int p;
x=right*factor-10;float yinte;float area=0.00,interec;int i;float k=0;int f=x/acc;

if(x<0)
{
for(i=0;i<=-f;i++)
{
  area=area+gh(k)*acc;
  k=k-acc;
}

yinte=-area;
for(p=0;p<iterations;p++)
{

y=ynot;
x+=acc;
ynot=gh(x);
yinte=yinte+ynot*acc;


	if ( y < 12+factor*up&& y> -12 +factor*up){
        w.RenderLine (Position(xnot,10-y+factor*up),Position(xnot+acc,10-ynot+factor*up),Blue,0.05);}
        if ( yinte < 12+factor*up&& yinte> -12 +factor*up){
	w.RenderLine (Position(xnot,10-yinte+factor*up),Position(xnot+acc,10-yinte+factor*up),Green,0.05);}
	xnot +=acc;
}
}
if(x>0)
{
for(i=0;i<=-f;i++)
{
area=area+gh(k)*acc;
k=k+acc;
}
yinte=area;
for(p=0;p<iterations;p++)
{

y=ynot;
x+=acc;
ynot=gh(x);
yinte=yinte+ynot*acc;


	if ( y < 12+factor*up&& y> -12 +factor*up){
        w.RenderLine (Position(xnot,10-y+factor*up),Position(xnot+acc,10-ynot+factor*up),Blue,0.05);}
        if ( yinte < 12+factor*up&& yinte> -12 +factor*up){
	w.RenderLine (Position(xnot,10-yinte+factor*up),Position(xnot+acc,10-yinte+factor*up),Green,0.05);}
	xnot +=acc;
}
}
if ( ifCritical == 1){
graphWithCriticalpoints (  factor,right, up, acc, iterations);}
if ( ifRoot == 1) {
 graphWithRoots (  factor, right,up, acc, iterations);}
}



/****************************************************************/
void graphWithDerivativeAndIntegral (  int factor,int right,int up,float acc,int iterations)
{
 graphWithIntegral ( factor,right,up,acc, iterations);
 graphWithDerivative ( factor,right,up,acc, iterations);
}



/******************************************************************/





/********************* plot actually plots the grid *****************************/
void plot ( int right ,int up)
{



//declariotin of variables for plot func
char number [10];
float acc = 0.01;
int iterations = 2000, i=0 , factor=5 , displayNumber;

//colors the background hiding all the previous data written there on the window
E.Draw ();// if the window is maximised this clears off the part where no graph is drawn
D.Draw ();// graph space made yellow




// drawing the axis
//draw the xaxis
w.RenderLine (Position (0.0,10+factor*up), Position (20.0,10.0 +factor*up), Black, 0.1);
//draw yaxis
w.RenderLine (Position (10.0 -factor*right,0.0), Position (10.0-factor*right,20.0), Black, 0.1);




//drawing grid
/******************************************/
int j;
// x axis
for (  j=0; j<20;j++)
{
w.RenderLine (Position (j,0.0), Position (j,20.0), Black, 0.01);
}
// y axis
for (  j=0; j<20;j++)
{
w.RenderLine (Position (0.0,j), Position (20.0,j), Black, 0.01);
}
/*********************************************/



//writing the coordinates
/***********************************************/

displayNumber = right*factor - 10;
for ( i=0; i< 20; i++, displayNumber++)// dispalying at x axis
{ 

sprintf (number,"%d", displayNumber);
  w.RenderText ( Position (i +0.1, 10.2+factor*up), Position (i+0.3, 10.3+factor*up), number, Black);   
}

displayNumber = up*factor +10;
for ( i=1; i< 21; i++,displayNumber--)// displaying at y axis
{ 

sprintf (number,"%d", displayNumber);
  w.RenderText ( Position (10.15- factor*right,i + 0.2 -1), Position (10.3- factor*right,i+0.3-1), number, Black);   
}
/**************************************************/


/*******functions for graph plot***********/
if ( ifDeri==0&& ifInt ==0){ graph ( factor,right,up,acc, iterations);}
if ( ifDeri==1&& ifInt ==0){ graphWithDerivative ( factor,right,up,acc, iterations);}
if ( ifDeri==0&& ifInt ==1){ graphWithIntegral ( factor,right,up,acc, iterations);}
if ( ifDeri==1&& ifInt ==1){graphWithDerivativeAndIntegral ( factor,right,up,acc, iterations);}
/**************************/




// redrawing the buttons over the graph
a.Draw ();
b.Draw ();
c.Draw ();
d.Draw ();
e.Draw ();
rightpic.SetPosition ( Position ( 19,2));
rightpic.Draw();
leftpic.SetPosition ( Position (16.7,2 ));
leftpic.Draw();
uppic.SetPosition ( Position ( 18,0.7));
uppic.Draw();
downpic.SetPosition ( Position ( 18,3));
downpic.Draw();

w.RenderText (Position (1,1), Position (2,2), "plot", Black);
plotpic.SetPosition (Position (1,1));
plotpic.Draw();
}

/*********************************************** main *********************************************/
/**************************************************************************************************/
int ApiMain ()
{
  
   
   float harry;
   puts ( "     ******************GRAPH PLOTTER********************      ");
   puts ( "     ***************************************************       ");
   
 puts("Enter an expression an press Enter to plot the graph.");
   printf("y = ");
    gets(str);
    harry = gh (0);
  
  
    
w.Open ();// creates the graph window



/******input window******/
input.Open ();
photo.Load ( "photo.xpm");
photo.SetPosition ( Position (0,0));
photo.Draw();
k.Draw();
f.Draw();
h.Draw();
j.Draw();
checked.Load ( "checked.xpm");
unchecked.Load ("checkun.xpm");

unchecked.SetPosition ( Position ( 1,4));

unchecked.Draw();
unchecked.SetPosition (Position (1,3));
unchecked.Draw();
unchecked.SetPosition (Position (1,5));
unchecked.Draw();
unchecked.SetPosition (Position (1,6));
unchecked.Draw();


input.RenderText (Position (0,0), Position (10,1), "***GRAPH PLOTTER***", Black);
input.RenderText (Position (4.7,3), Position (3,4), "Derivative  (cyan)", Black);
input.RenderText (Position (4.7,4), Position (4,5), "Integral(green)", Black);
input.RenderText (Position (4.7,5), Position (4,6), "Critical points", Black);
input.RenderText (Position (4.7,6), Position (4,7), "Roots of function", Black);
input.RenderText (Position (6,8), Position (7,9), "DONE", Black);
input.RenderText (Position (1.5,1.5),Position (7.5,2.5),str,Black);
input.SetMouseClickCallback ( inputMouseClick);


/************************/
rightpic.Load ( "right1.xpm");
leftpic.Load ( "left.xpm");
uppic.Load ("up.xpm");
downpic.Load("down.xpm");
plotpic.Load("plot.xpm");



// initial makeup of graph window 
/*******************************/
D.Draw ();

//draw the xaxis
w.RenderLine (Position (0.0,10.0), Position (20.0,10.0), Black, 0.1);
//draw yaxis
w.RenderLine (Position (10.0,0.0), Position (10.0,20.0), Black, 0.1);



// draw grid
int j;
// x axis
for (  j=0; j<20;j++)
{
w.RenderLine (Position (j,0.0), Position (j,20.0), Black, 0.01);
}
// y axis
for (  j=0; j<20;j++)
{
w.RenderLine (Position (0.0,j), Position (20.0,j), Black, 0.01);
}




a.Draw ();
b.Draw ();
c.Draw ();
d.Draw ();
e.Draw ();
rightpic.SetPosition ( Position ( 19,2));
rightpic.Draw();
leftpic.SetPosition ( Position (16.7,2 ));
leftpic.Draw();
uppic.SetPosition ( Position ( 18,0.7));
uppic.Draw();
downpic.SetPosition ( Position ( 18,3));
downpic.Draw();
w.RenderText (Position (1,1), Position (2,2), "plot", Black);
plotpic.SetPosition (Position (1,1));
plotpic.Draw();
/********************************/




// function that handles all the mouse clicks on the graph.....
w.SetMouseClickCallback ( wMouseClick);



return 0;
}


/************************************closing the program*********************************/
int ApiEnd ()
{
w.Close ();
return 0;
}






